Coco/R - Compiler-Compiler V1.47 (for Pascal)
Turbo Pascal (TM) version by Volker Pohlers/Pat Terry 05 November 1998
Source file: OP4.ATG

Grammar Tests:

Deletable symbols:
     ClassVisibility
     ExceptBlock
     StmtList
     Statement
List of first & follow symbols:

UnitId
first:   "_Uid"  
follow:  "."  

InterfaceHeritage
first:   "("  
follow:  "END"  "PROCEDURE"  "CONSTRUCTOR"  "DESTRUCTOR"  "FUNCTION"  
         "PROPERTY"  

AccessSpecifier
first:   "read"  "write"  "readonly"  "writeonly"  
follow:  "END"  "PROCEDURE"  "CONSTRUCTOR"  "DESTRUCTOR"  "FUNCTION"  
         "PROPERTY"  "public"  "protected"  "private"  "published"  
         "automated"  "stored"  "default"  "nodefault"  "read"  "write"  
         "readonly"  "writeonly"  "implements"  

StorageSpecifier
first:   "stored"  "default"  "nodefault"  
follow:  "END"  "PROCEDURE"  "CONSTRUCTOR"  "DESTRUCTOR"  "FUNCTION"  
         "PROPERTY"  "public"  "protected"  "private"  "published"  
         "automated"  "implements"  

PropertyParameterList
first:   bracketOpn  
follow:  ":"  

PropertySpecifiers
first:   "index"  "read"  "write"  "readonly"  "writeonly"  
follow:  "END"  "PROCEDURE"  "CONSTRUCTOR"  "DESTRUCTOR"  "FUNCTION"  
         "PROPERTY"  "public"  "protected"  "private"  "published"  
         "automated"  

PropertyInterface
first:   bracketOpn  ":"  
follow:  "index"  "read"  "write"  "readonly"  "writeonly"  

ClsMethodHeading
first:   "PROCEDURE"  "CONSTRUCTOR"  "DESTRUCTOR"  "FUNCTION"  
follow:  ";"  

ClsFuncHeading
first:   "FUNCTION"  
follow:  ";"  

ClsProcHeading
first:   "PROCEDURE"  
follow:  ";"  

MethodResolution
first:   "."  
follow:  ";"  

ClsMthProp
first:   "PROCEDURE"  "CONSTRUCTOR"  "DESTRUCTOR"  "FUNCTION"  "PROPERTY"  
follow:  "END"  "PROCEDURE"  "CONSTRUCTOR"  "DESTRUCTOR"  "FUNCTION"  
         "PROPERTY"  "public"  "protected"  "private"  "published"  
         "automated"  

ClassHeritage
first:   "("  
follow:  ident  "END"  "PROCEDURE"  "CONSTRUCTOR"  "DESTRUCTOR"  "FUNCTION"  
         "PROPERTY"  "public"  "protected"  "private"  "published"  
         "automated"  

DestructorHeading
first:   "DESTRUCTOR"  
follow:  ";"  

ConstructorHeading
first:   "CONSTRUCTOR"  
follow:  ";"  

MethodHeading
first:   "PROCEDURE"  "CONSTRUCTOR"  "DESTRUCTOR"  "FUNCTION"  
follow:  ";"  

ObjMth
first:   "PROCEDURE"  "CONSTRUCTOR"  "DESTRUCTOR"  "FUNCTION"  
follow:  "END"  "PROCEDURE"  "CONSTRUCTOR"  "DESTRUCTOR"  "FUNCTION"  
         "public"  "protected"  "private"  "published"  "automated"  

ObjFld
first:   ident  
follow:  ident  "END"  "PROCEDURE"  "CONSTRUCTOR"  "DESTRUCTOR"  "FUNCTION"  
         "PROPERTY"  "public"  "protected"  "private"  "published"  
         "automated"  

ClassVisibility
first:   "public"  "protected"  "private"  "published"  "automated"  
follow:  ident  "END"  "PROCEDURE"  "CONSTRUCTOR"  "DESTRUCTOR"  "FUNCTION"  
         "PROPERTY"  

ObjHeritage
first:   "("  
follow:  ident  "END"  "PROCEDURE"  "CONSTRUCTOR"  "DESTRUCTOR"  "FUNCTION"  
         "public"  "protected"  "private"  "published"  "automated"  

Dir16Bit
first:   "near"  "far"  "export"  
follow:  ";"  "LABEL"  "CONST"  "RESOURCESTRING"  ":"  "TYPE"  "VAR"  
         "THREADVAR"  "BEGIN"  "PROCEDURE"  "CONSTRUCTOR"  "DESTRUCTOR"  
         "FUNCTION"  "cdecl"  "register"  "pascal"  "safecall"  "stdcall"  
         "virtual"  "dynamic"  "message"  "override"  "overload"  
         "reintroduce"  "near"  "far"  "export"  "external"  "forward"  
         "abstract"  

DirBinding
first:   "virtual"  "dynamic"  "message"  "override"  "overload"  
         "reintroduce"  
follow:  ";"  "LABEL"  "CONST"  "RESOURCESTRING"  ":"  "TYPE"  "VAR"  
         "THREADVAR"  "BEGIN"  "PROCEDURE"  "CONSTRUCTOR"  "DESTRUCTOR"  
         "FUNCTION"  "cdecl"  "register"  "pascal"  "safecall"  "stdcall"  
         "virtual"  "dynamic"  "message"  "override"  "overload"  
         "reintroduce"  "near"  "far"  "export"  "external"  "forward"  
         "abstract"  

Parameter
first:   ident  ":"  
follow:  ")"  ";"  

FormalParm
first:   ident  "CONST"  ":"  "VAR"  "OUT"  
follow:  ")"  ";"  

ReturnType
first:   "("  "CLASS"  "real48"  "real"  "single"  "double"  "extended"  
         "currency"  "comp"  "boolean"  "bytebool"  "wordbool"  "longbool"  
         "char"  "widechar"  "ansichar"  "integer"  "cardinal"  "shortint"  
         "smallint"  "longint"  "int64"  "byte"  "word"  "longword"  "pchar"  
         "shortstring"  "ansistring"  "widestring"  "STRING"  "_constExpr"  
follow:  ")"  ";"  "END"  "LABEL"  "CONST"  "RESOURCESTRING"  "="  "TYPE"  
         "OF"  "CASE"  "VAR"  "THREADVAR"  "absolute"  "BEGIN"  "PROCEDURE"  
         "CONSTRUCTOR"  "DESTRUCTOR"  "FUNCTION"  "cdecl"  "register"  
         "pascal"  "safecall"  "stdcall"  

FormalParameters
first:   "("  
follow:  ")"  ";"  "END"  "LABEL"  "CONST"  "RESOURCESTRING"  "="  ":"  
         "TYPE"  "OF"  "CASE"  "VAR"  "THREADVAR"  "absolute"  "BEGIN"  
         "PROCEDURE"  "CONSTRUCTOR"  "DESTRUCTOR"  "FUNCTION"  "cdecl"  
         "register"  "pascal"  "safecall"  "stdcall"  "virtual"  "dynamic"  
         "message"  "override"  "overload"  "reintroduce"  "near"  "far"  
         "export"  "external"  "forward"  "abstract"  

FuncMtDecl
first:   "FUNCTION"  
follow:  "END"  "EXPORTS"  "LABEL"  "CONST"  "RESOURCESTRING"  "TYPE"  "VAR"  
         "THREADVAR"  "BEGIN"  "PROCEDURE"  "CONSTRUCTOR"  "DESTRUCTOR"  
         "FUNCTION"  "INITIALIZATION"  

ProcMtDecl
first:   "PROCEDURE"  "CONSTRUCTOR"  "DESTRUCTOR"  
follow:  "END"  "EXPORTS"  "LABEL"  "CONST"  "RESOURCESTRING"  "TYPE"  "VAR"  
         "THREADVAR"  "BEGIN"  "PROCEDURE"  "CONSTRUCTOR"  "DESTRUCTOR"  
         "FUNCTION"  "INITIALIZATION"  

ForStmt
first:   "FOR"  
follow:  ";"  "END"  "EXCEPT"  "FINALLY"  "ELSE"  "UNTIL"  "FINALIZATION"  

WhileStmt
first:   "WHILE"  
follow:  ";"  "END"  "EXCEPT"  "FINALLY"  "ELSE"  "UNTIL"  "FINALIZATION"  

RepeatStmt
first:   "REPEAT"  
follow:  ";"  "END"  "EXCEPT"  "FINALLY"  "ELSE"  "UNTIL"  "FINALIZATION"  

CaseLabel
first:   "_constExpr"  
follow:  ","  ":"  

CaseSelector
first:   "_constExpr"  
follow:  ";"  "END"  "ELSE"  

CaseStmt
first:   "CASE"  
follow:  ";"  "END"  "EXCEPT"  "FINALLY"  "ELSE"  "UNTIL"  "FINALIZATION"  

IfStmt
first:   "IF"  
follow:  ";"  "END"  "EXCEPT"  "FINALLY"  "ELSE"  "UNTIL"  "FINALIZATION"  

ExceptionHandler
first:   "ON"  
follow:  ";"  "END"  "ELSE"  

ExceptBlock
first:   ident  intConst  ";"  "CASE"  "INHERITED"  "GOTO"  "INLINE"  "ASM"  
         "TRY"  "ELSE"  "ON"  "RAISE"  "BEGIN"  "IF"  "REPEAT"  "WHILE"  
         "FOR"  "WITH"  "_Lid"  
follow:  "END"  

AsmCode
first:   "_ASM"  
follow:  ";"  "END"  

InlineStmt
first:   "INLINE"  
follow:  ";"  "END"  "EXCEPT"  "FINALLY"  "ELSE"  "UNTIL"  "FINALIZATION"  

AsmStmt
first:   "ASM"  
follow:  ";"  "END"  "EXCEPT"  "FINALLY"  "ELSE"  "UNTIL"  "FINALIZATION"  

RaiseStmt
first:   "RAISE"  
follow:  ";"  "END"  "EXCEPT"  "FINALLY"  "ELSE"  "UNTIL"  "FINALIZATION"  

ExceptStmt
first:   "TRY"  
follow:  ";"  "END"  "EXCEPT"  "FINALLY"  "ELSE"  "UNTIL"  "FINALIZATION"  

WithStmt
first:   "WITH"  
follow:  ";"  "END"  "EXCEPT"  "FINALLY"  "ELSE"  "UNTIL"  "FINALIZATION"  

LoopStmt
first:   "REPEAT"  "WHILE"  "FOR"  
follow:  ";"  "END"  "EXCEPT"  "FINALLY"  "ELSE"  "UNTIL"  "FINALIZATION"  

ConditionalStmt
first:   "CASE"  "IF"  
follow:  ";"  "END"  "EXCEPT"  "FINALLY"  "ELSE"  "UNTIL"  "FINALIZATION"  

StmtList
first:   ident  intConst  ";"  "CASE"  "INHERITED"  "GOTO"  "INLINE"  "ASM"  
         "TRY"  "RAISE"  "BEGIN"  "IF"  "REPEAT"  "WHILE"  "FOR"  "WITH"  
         "_Lid"  
follow:  "END"  "EXCEPT"  "FINALLY"  "UNTIL"  "FINALIZATION"  

StructStmt
first:   "CASE"  "INLINE"  "ASM"  "TRY"  "RAISE"  "BEGIN"  "IF"  "REPEAT"  
         "WHILE"  "FOR"  "WITH"  
follow:  ";"  "END"  "EXCEPT"  "FINALLY"  "ELSE"  "UNTIL"  "FINALIZATION"  

SimpleStatement
first:   ident  "INHERITED"  "GOTO"  
follow:  ";"  "END"  "EXCEPT"  "FINALLY"  "ELSE"  "UNTIL"  "FINALIZATION"  

Statement
first:   ident  intConst  "CASE"  "INHERITED"  "GOTO"  "INLINE"  "ASM"  "TRY"  
         "RAISE"  "BEGIN"  "IF"  "REPEAT"  "WHILE"  "FOR"  "WITH"  "_Lid"  
follow:  ";"  "END"  "EXCEPT"  "FINALLY"  "ELSE"  "UNTIL"  "FINALIZATION"  

SetElement
first:   bracketOpn  ident  intConst  realConst  quotedStr  controlChr  "("  
         "+"  "-"  "@"  "NIL"  "NOT"  "_Tid"  "_Uid"  
follow:  bracketCls  ","  

QualId
first:   ident  
follow:  bracketOpn  bracketCls  "("  ")"  ";"  "."  "END"  ","  "IN"  
         "LABEL"  "CONST"  "RESOURCESTRING"  ":"  "TYPE"  "OF"  ".."  "^"  
         "VAR"  "THREADVAR"  "+"  "-"  ">"  "<"  "<="  ">="  "<>"  "IS"  "AS"  
         "OR"  "XOR"  "*"  "/"  "DIV"  "MOD"  "AND"  "SHL"  "SHR"  ":="  
         "EXCEPT"  "FINALLY"  "ELSE"  "DO"  "AT"  "BEGIN"  "THEN"  "UNTIL"  
         "TO"  "DOWNTO"  "PROCEDURE"  "CONSTRUCTOR"  "DESTRUCTOR"  "FUNCTION"  
         "cdecl"  "register"  "pascal"  "safecall"  "stdcall"  "virtual"  
         "dynamic"  "message"  "override"  "overload"  "reintroduce"  "near"  
         "far"  "export"  "external"  "forward"  "abstract"  "FINALIZATION"  

SetConstructor
first:   bracketOpn  
follow:  bracketCls  ")"  ";"  "END"  ","  "IN"  "OF"  ".."  "+"  "-"  ">"  
         "<"  "<="  ">="  "<>"  "IS"  "AS"  "OR"  "XOR"  "*"  "/"  "DIV"  
         "MOD"  "AND"  "SHL"  "SHR"  "EXCEPT"  "FINALLY"  "ELSE"  "DO"  
         "THEN"  "UNTIL"  "TO"  "DOWNTO"  "FINALIZATION"  

Number
first:   intConst  realConst  
follow:  bracketCls  ")"  ";"  "END"  ","  "IN"  "OF"  ".."  "+"  "-"  ">"  
         "<"  "<="  ">="  "<>"  "IS"  "AS"  "OR"  "XOR"  "*"  "/"  "DIV"  
         "MOD"  "AND"  "SHL"  "SHR"  "EXCEPT"  "FINALLY"  "ELSE"  "DO"  
         "THEN"  "UNTIL"  "TO"  "DOWNTO"  "FINALIZATION"  

ExprList
first:   bracketOpn  ident  intConst  realConst  quotedStr  controlChr  "("  
         "+"  "-"  "@"  "NIL"  "NOT"  "_Tid"  "_Uid"  
follow:  bracketCls  ")"  

Designator
first:   ident  
follow:  bracketCls  "("  ")"  ";"  "END"  ","  "IN"  "OF"  ".."  "+"  "-"  
         ">"  "<"  "<="  ">="  "<>"  "IS"  "AS"  "OR"  "XOR"  "*"  "/"  "DIV"  
         "MOD"  "AND"  "SHL"  "SHR"  ":="  "EXCEPT"  "FINALLY"  "ELSE"  "DO"  
         "AT"  "THEN"  "UNTIL"  "TO"  "DOWNTO"  "FINALIZATION"  

MulOp
first:   "*"  "/"  "DIV"  "MOD"  "AND"  "SHL"  "SHR"  
follow:  bracketOpn  ident  intConst  realConst  quotedStr  controlChr  "("  
         "@"  "NIL"  "NOT"  "_Tid"  "_Uid"  

Factor
first:   bracketOpn  ident  intConst  realConst  quotedStr  controlChr  "("  
         "@"  "NIL"  "NOT"  "_Tid"  "_Uid"  
follow:  bracketCls  ")"  ";"  "END"  ","  "IN"  "OF"  ".."  "+"  "-"  ">"  
         "<"  "<="  ">="  "<>"  "IS"  "AS"  "OR"  "XOR"  "*"  "/"  "DIV"  
         "MOD"  "AND"  "SHL"  "SHR"  "EXCEPT"  "FINALLY"  "ELSE"  "DO"  
         "THEN"  "UNTIL"  "TO"  "DOWNTO"  "FINALIZATION"  

AddOp
first:   "+"  "-"  "OR"  "XOR"  
follow:  bracketOpn  ident  intConst  realConst  quotedStr  controlChr  "("  
         "@"  "NIL"  "NOT"  "_Tid"  "_Uid"  

Term
first:   bracketOpn  ident  intConst  realConst  quotedStr  controlChr  "("  
         "@"  "NIL"  "NOT"  "_Tid"  "_Uid"  
follow:  bracketCls  ")"  ";"  "END"  ","  "IN"  "OF"  ".."  "+"  "-"  ">"  
         "<"  "<="  ">="  "<>"  "IS"  "AS"  "OR"  "XOR"  "EXCEPT"  "FINALLY"  
         "ELSE"  "DO"  "THEN"  "UNTIL"  "TO"  "DOWNTO"  "FINALIZATION"  

RelOp
first:   "IN"  ">"  "<"  "<="  ">="  "<>"  "IS"  "AS"  
follow:  bracketOpn  ident  intConst  realConst  quotedStr  controlChr  "("  
         "+"  "-"  "@"  "NIL"  "NOT"  "_Tid"  "_Uid"  

SimpleExpression
first:   bracketOpn  ident  intConst  realConst  quotedStr  controlChr  "("  
         "+"  "-"  "@"  "NIL"  "NOT"  "_Tid"  "_Uid"  
follow:  bracketCls  ")"  ";"  "END"  ","  "IN"  "OF"  ".."  ">"  "<"  "<="  
         ">="  "<>"  "IS"  "AS"  "EXCEPT"  "FINALLY"  "ELSE"  "DO"  "THEN"  
         "UNTIL"  "TO"  "DOWNTO"  "FINALIZATION"  

Expression
first:   bracketOpn  ident  intConst  realConst  quotedStr  controlChr  "("  
         "+"  "-"  "@"  "NIL"  "NOT"  "_Tid"  "_Uid"  
follow:  bracketCls  ")"  ";"  "END"  ","  "OF"  ".."  "EXCEPT"  "FINALLY"  
         "ELSE"  "DO"  "THEN"  "UNTIL"  "TO"  "DOWNTO"  "FINALIZATION"  

VarDecl
first:   ident  
follow:  ";"  

DirCalling
first:   "cdecl"  "register"  "pascal"  "safecall"  "stdcall"  
follow:  ")"  ";"  "END"  "LABEL"  "CONST"  "RESOURCESTRING"  "="  ":"  
         "TYPE"  "CASE"  "VAR"  "THREADVAR"  "absolute"  "BEGIN"  "PROCEDURE"  
         "CONSTRUCTOR"  "DESTRUCTOR"  "FUNCTION"  "cdecl"  "register"  
         "pascal"  "safecall"  "stdcall"  "virtual"  "dynamic"  "message"  
         "override"  "overload"  "reintroduce"  "near"  "far"  "export"  
         "external"  "forward"  "abstract"  

RecVariant
first:   "_constExpr"  
follow:  ")"  ";"  "END"  

VariantSection
first:   "CASE"  
follow:  ")"  ";"  "END"  

FieldDecl
first:   ident  
follow:  ")"  ";"  "END"  "CASE"  

FieldList
first:   ident  
follow:  ")"  "END"  

RecType
first:   "RECORD"  
follow:  ")"  ";"  "END"  "="  "CASE"  "absolute"  

FileType
first:   "FILE"  
follow:  ")"  ";"  "END"  "="  "CASE"  "absolute"  

SetType
first:   "SET"  
follow:  ")"  ";"  "END"  "="  "CASE"  "absolute"  

ArrayType
first:   "ARRAY"  
follow:  ")"  ";"  "END"  "="  "CASE"  "absolute"  

OrdIdent
first:   "boolean"  "bytebool"  "wordbool"  "longbool"  "char"  "widechar"  
         "ansichar"  "integer"  "cardinal"  "shortint"  "smallint"  "longint"  
         "int64"  "byte"  "word"  "longword"  "pchar"  
follow:  bracketCls  ")"  ";"  "END"  ","  "LABEL"  "CONST"  "RESOURCESTRING"  
         "="  "TYPE"  "OF"  "CASE"  "VAR"  "THREADVAR"  "absolute"  "BEGIN"  
         "PROCEDURE"  "CONSTRUCTOR"  "DESTRUCTOR"  "FUNCTION"  "cdecl"  
         "register"  "pascal"  "safecall"  "stdcall"  

EnumeratedType
first:   "("  
follow:  bracketCls  ")"  ";"  "END"  ","  "LABEL"  "CONST"  "RESOURCESTRING"  
         "="  "TYPE"  "OF"  "CASE"  "VAR"  "THREADVAR"  "absolute"  "BEGIN"  
         "PROCEDURE"  "CONSTRUCTOR"  "DESTRUCTOR"  "FUNCTION"  "cdecl"  
         "register"  "pascal"  "safecall"  "stdcall"  

SubrangeType
first:   "_constExpr"  
follow:  bracketCls  ")"  ";"  "END"  ","  "LABEL"  "CONST"  "RESOURCESTRING"  
         "="  "TYPE"  "OF"  "CASE"  "VAR"  "THREADVAR"  "absolute"  "BEGIN"  
         "PROCEDURE"  "CONSTRUCTOR"  "DESTRUCTOR"  "FUNCTION"  "cdecl"  
         "register"  "pascal"  "safecall"  "stdcall"  

RealType
first:   "real48"  "real"  "single"  "double"  "extended"  "currency"  "comp"  
follow:  ")"  ";"  "END"  "LABEL"  "CONST"  "RESOURCESTRING"  "="  "TYPE"  
         "OF"  "CASE"  "VAR"  "THREADVAR"  "absolute"  "BEGIN"  "PROCEDURE"  
         "CONSTRUCTOR"  "DESTRUCTOR"  "FUNCTION"  "cdecl"  "register"  
         "pascal"  "safecall"  "stdcall"  

OrdinalType
first:   "("  "boolean"  "bytebool"  "wordbool"  "longbool"  "char"  
         "widechar"  "ansichar"  "integer"  "cardinal"  "shortint"  
         "smallint"  "longint"  "int64"  "byte"  "word"  "longword"  "pchar"  
         "_constExpr"  
follow:  bracketCls  ")"  ";"  "END"  ","  "LABEL"  "CONST"  "RESOURCESTRING"  
         "="  "TYPE"  "OF"  "CASE"  "VAR"  "THREADVAR"  "absolute"  "BEGIN"  
         "PROCEDURE"  "CONSTRUCTOR"  "DESTRUCTOR"  "FUNCTION"  "cdecl"  
         "register"  "pascal"  "safecall"  "stdcall"  

InterfaceType
first:   "INTERFACE"  "DISPINTERFACE"  
follow:  ";"  

ClassType
first:   "CLASS"  
follow:  ")"  ";"  "END"  "LABEL"  "CONST"  "RESOURCESTRING"  "="  "TYPE"  
         "OF"  "CASE"  "VAR"  "THREADVAR"  "absolute"  "BEGIN"  "PROCEDURE"  
         "CONSTRUCTOR"  "DESTRUCTOR"  "FUNCTION"  "cdecl"  "register"  
         "pascal"  "safecall"  "stdcall"  

ObjectType
first:   "OBJECT"  
follow:  ";"  

ClassRefType
first:   "CLASS"  
follow:  ")"  ";"  "END"  "="  "CASE"  "absolute"  

VariantType
first:   "VARIANT"  "OLEVARIANT"  
follow:  ")"  ";"  "END"  "="  "CASE"  "absolute"  

ProcedureType
first:   "PROCEDURE"  "FUNCTION"  
follow:  ")"  ";"  "END"  "="  "CASE"  "absolute"  

StringType
first:   "shortstring"  "ansistring"  "widestring"  "STRING"  
follow:  ")"  ";"  "END"  "LABEL"  "CONST"  "RESOURCESTRING"  "="  "TYPE"  
         "OF"  "CASE"  "VAR"  "THREADVAR"  "absolute"  "BEGIN"  "PROCEDURE"  
         "CONSTRUCTOR"  "DESTRUCTOR"  "FUNCTION"  "cdecl"  "register"  
         "pascal"  "safecall"  "stdcall"  

PointerType
first:   "^"  
follow:  ")"  ";"  "END"  "="  "CASE"  "absolute"  

StrucType
first:   "PACKED"  "ARRAY"  "RECORD"  "SET"  "FILE"  
follow:  ")"  ";"  "END"  "="  "CASE"  "absolute"  

SimpleType
first:   "("  "real48"  "real"  "single"  "double"  "extended"  "currency"  
         "comp"  "boolean"  "bytebool"  "wordbool"  "longbool"  "char"  
         "widechar"  "ansichar"  "integer"  "cardinal"  "shortint"  
         "smallint"  "longint"  "int64"  "byte"  "word"  "longword"  "pchar"  
         "_constExpr"  
follow:  ")"  ";"  "END"  "LABEL"  "CONST"  "RESOURCESTRING"  "="  "TYPE"  
         "OF"  "CASE"  "VAR"  "THREADVAR"  "absolute"  "BEGIN"  "PROCEDURE"  
         "CONSTRUCTOR"  "DESTRUCTOR"  "FUNCTION"  "cdecl"  "register"  
         "pascal"  "safecall"  "stdcall"  

RecordFieldConstant
first:   ident  
follow:  ")"  ";"  

RecordConstant
first:   "("  
follow:  ")"  ";"  ","  

ArrayConstant
first:   "("  
follow:  ")"  ";"  ","  

RestrictedType
first:   "INTERFACE"  "CLASS"  "OBJECT"  "DISPINTERFACE"  
follow:  ";"  

Type
first:   "("  "CLASS"  "real48"  "real"  "single"  "double"  "extended"  
         "currency"  "comp"  "boolean"  "bytebool"  "wordbool"  "longbool"  
         "char"  "widechar"  "ansichar"  "integer"  "cardinal"  "shortint"  
         "smallint"  "longint"  "int64"  "byte"  "word"  "longword"  "pchar"  
         "VARIANT"  "OLEVARIANT"  "shortstring"  "ansistring"  "widestring"  
         "STRING"  "PACKED"  "ARRAY"  "RECORD"  "SET"  "FILE"  "^"  
         "PROCEDURE"  "FUNCTION"  "_Tid"  "_constExpr"  "_Uid"  
follow:  ")"  ";"  "END"  "="  "CASE"  "absolute"  

TypeDecl
first:   ident  "INTERFACE"  "CLASS"  "OBJECT"  "DISPINTERFACE"  
follow:  ";"  

TypedConstant
first:   "("  "_constExpr"  
follow:  ")"  ";"  ","  

TypeId
first:   "_Tid"  "_Uid"  
follow:  bracketCls  "("  ")"  ";"  "END"  "="  "OF"  "CASE"  "absolute"  
         "PROCEDURE"  "CONSTRUCTOR"  "DESTRUCTOR"  "FUNCTION"  "PROPERTY"  
         "public"  "protected"  "private"  "published"  "automated"  

ConstExpr
first:   "_constExpr"  
follow:  bracketCls  ")"  ";"  "END"  ","  "LABEL"  "CONST"  "RESOURCESTRING"  
         "="  ":"  "TYPE"  "OF"  ".."  "CASE"  "VAR"  "THREADVAR"  "absolute"  
         "BEGIN"  "PROCEDURE"  "CONSTRUCTOR"  "DESTRUCTOR"  "FUNCTION"  
         "cdecl"  "register"  "pascal"  "safecall"  "stdcall"  "virtual"  
         "dynamic"  "message"  "override"  "overload"  "reintroduce"  "near"  
         "far"  "export"  "external"  "forward"  "abstract"  "PROPERTY"  
         "public"  "protected"  "private"  "published"  "automated"  "read"  
         "write"  "readonly"  "writeonly"  "implements"  

ResourceDecl
first:   "RESOURCESTRING"  
follow:  "END"  "EXPORTS"  "IMPLEMENTATION"  "LABEL"  "CONST"  
         "RESOURCESTRING"  "TYPE"  "VAR"  "THREADVAR"  "BEGIN"  "PROCEDURE"  
         "CONSTRUCTOR"  "DESTRUCTOR"  "FUNCTION"  "INITIALIZATION"  

ConstantDecl
first:   ident  
follow:  ";"  

LabelId
first:   intConst  "_Lid"  
follow:  ";"  "END"  "EXPORTS"  ","  "LABEL"  "CONST"  "RESOURCESTRING"  ":"  
         "TYPE"  "VAR"  "THREADVAR"  "EXCEPT"  "FINALLY"  "ELSE"  "BEGIN"  
         "UNTIL"  "PROCEDURE"  "CONSTRUCTOR"  "DESTRUCTOR"  "FUNCTION"  
         "INITIALIZATION"  "FINALIZATION"  

ProcedureDeclSection
first:   "PROCEDURE"  "CONSTRUCTOR"  "DESTRUCTOR"  "FUNCTION"  
follow:  "END"  "EXPORTS"  "LABEL"  "CONST"  "RESOURCESTRING"  "TYPE"  "VAR"  
         "THREADVAR"  "BEGIN"  "PROCEDURE"  "CONSTRUCTOR"  "DESTRUCTOR"  
         "FUNCTION"  "INITIALIZATION"  

LabelDeclSection
first:   "LABEL"  
follow:  "END"  "EXPORTS"  "LABEL"  "CONST"  "RESOURCESTRING"  "TYPE"  "VAR"  
         "THREADVAR"  "BEGIN"  "PROCEDURE"  "CONSTRUCTOR"  "DESTRUCTOR"  
         "FUNCTION"  "INITIALIZATION"  

Directive
first:   "cdecl"  "register"  "pascal"  "safecall"  "stdcall"  "virtual"  
         "dynamic"  "message"  "override"  "overload"  "reintroduce"  "near"  
         "far"  "export"  "external"  "forward"  "abstract"  
follow:  ";"  "LABEL"  "CONST"  "RESOURCESTRING"  ":"  "TYPE"  "VAR"  
         "THREADVAR"  "BEGIN"  "PROCEDURE"  "CONSTRUCTOR"  "DESTRUCTOR"  
         "FUNCTION"  "cdecl"  "register"  "pascal"  "safecall"  "stdcall"  
         "virtual"  "dynamic"  "message"  "override"  "overload"  
         "reintroduce"  "near"  "far"  "export"  "external"  "forward"  
         "abstract"  

FunctionHeading
first:   "FUNCTION"  
follow:  ")"  ";"  "END"  "="  "OF"  "CASE"  "absolute"  "cdecl"  "register"  
         "pascal"  "safecall"  "stdcall"  

ProcedureHeading
first:   "PROCEDURE"  
follow:  ")"  ";"  "END"  "="  "OF"  "CASE"  "absolute"  "cdecl"  "register"  
         "pascal"  "safecall"  "stdcall"  

ExportedHeading
first:   "PROCEDURE"  "FUNCTION"  
follow:  "IMPLEMENTATION"  "CONST"  "RESOURCESTRING"  "TYPE"  "VAR"  
         "THREADVAR"  "PROCEDURE"  "FUNCTION"  

VarSection
first:   "VAR"  "THREADVAR"  
follow:  "END"  "EXPORTS"  "IMPLEMENTATION"  "LABEL"  "CONST"  
         "RESOURCESTRING"  "TYPE"  "VAR"  "THREADVAR"  "BEGIN"  "PROCEDURE"  
         "CONSTRUCTOR"  "DESTRUCTOR"  "FUNCTION"  "INITIALIZATION"  

TypeSection
first:   "TYPE"  
follow:  "END"  "EXPORTS"  "IMPLEMENTATION"  "LABEL"  "CONST"  
         "RESOURCESTRING"  "TYPE"  "VAR"  "THREADVAR"  "BEGIN"  "PROCEDURE"  
         "CONSTRUCTOR"  "DESTRUCTOR"  "FUNCTION"  "INITIALIZATION"  

ConstSection
first:   "CONST"  "RESOURCESTRING"  
follow:  "END"  "EXPORTS"  "IMPLEMENTATION"  "LABEL"  "CONST"  
         "RESOURCESTRING"  "TYPE"  "VAR"  "THREADVAR"  "BEGIN"  "PROCEDURE"  
         "CONSTRUCTOR"  "DESTRUCTOR"  "FUNCTION"  "INITIALIZATION"  

InterfaceDecl
first:   "CONST"  "RESOURCESTRING"  "TYPE"  "VAR"  "THREADVAR"  "PROCEDURE"  
         "FUNCTION"  
follow:  "IMPLEMENTATION"  "CONST"  "RESOURCESTRING"  "TYPE"  "VAR"  
         "THREADVAR"  "PROCEDURE"  "FUNCTION"  

Block
first:   "LABEL"  "CONST"  "RESOURCESTRING"  "TYPE"  "VAR"  "THREADVAR"  
         "BEGIN"  "PROCEDURE"  "CONSTRUCTOR"  "DESTRUCTOR"  "FUNCTION"  
follow:  ";"  "."  

ExpElem
first:   ident  
follow:  ";"  ","  

CompoundStmt
first:   "BEGIN"  
follow:  ";"  "."  "END"  "EXCEPT"  "FINALLY"  "ELSE"  "UNTIL"  
         "FINALIZATION"  

DeclSection
first:   "LABEL"  "CONST"  "RESOURCESTRING"  "TYPE"  "VAR"  "THREADVAR"  
         "PROCEDURE"  "CONSTRUCTOR"  "DESTRUCTOR"  "FUNCTION"  
follow:  "END"  "EXPORTS"  "LABEL"  "CONST"  "RESOURCESTRING"  "TYPE"  "VAR"  
         "THREADVAR"  "BEGIN"  "PROCEDURE"  "CONSTRUCTOR"  "DESTRUCTOR"  
         "FUNCTION"  "INITIALIZATION"  

ExportsClause
first:   "EXPORTS"  
follow:  "EXPORTS"  "LABEL"  "CONST"  "RESOURCESTRING"  "TYPE"  "VAR"  
         "THREADVAR"  "BEGIN"  "PROCEDURE"  "CONSTRUCTOR"  "DESTRUCTOR"  
         "FUNCTION"  

UsesClause
first:   "USES"  
follow:  "END"  "EXPORTS"  "IMPLEMENTATION"  "LABEL"  "CONST"  
         "RESOURCESTRING"  "TYPE"  "VAR"  "THREADVAR"  "BEGIN"  "PROCEDURE"  
         "CONSTRUCTOR"  "DESTRUCTOR"  "FUNCTION"  "INITIALIZATION"  

ContainsClause
first:   "contains"  
follow:  "END"  

RequiresClause
first:   "requires"  
follow:  "END"  "contains"  

InitSection
first:   "END"  "BEGIN"  "INITIALIZATION"  
follow:  "."  

ImplementationSection
first:   "IMPLEMENTATION"  
follow:  "END"  "BEGIN"  "INITIALIZATION"  

InterfaceSection
first:   "INTERFACE"  
follow:  "IMPLEMENTATION"  

ProgramBlock
first:   "USES"  "LABEL"  "CONST"  "RESOURCESTRING"  "TYPE"  "VAR"  
         "THREADVAR"  "BEGIN"  "PROCEDURE"  "CONSTRUCTOR"  "DESTRUCTOR"  
         "FUNCTION"  
follow:  "."  

IdentList
first:   ident  
follow:  ident  ")"  ";"  ":"  "DO"  

Unit
first:   "UNIT"  
follow:  -- empty set --

Library
first:   "LIBRARY"  
follow:  -- empty set --

Package
first:   "package"  
follow:  -- empty set --

Program
first:   "PROGRAM"  "USES"  "LABEL"  "CONST"  "RESOURCESTRING"  "TYPE"  "VAR"  
         "THREADVAR"  "BEGIN"  "PROCEDURE"  "CONSTRUCTOR"  "DESTRUCTOR"  
         "FUNCTION"  
follow:  -- empty set --

Op4
first:   "PROGRAM"  "UNIT"  "package"  "LIBRARY"  "USES"  "LABEL"  "CONST"  
         "RESOURCESTRING"  "TYPE"  "VAR"  "THREADVAR"  "BEGIN"  "PROCEDURE"  
         "CONSTRUCTOR"  "DESTRUCTOR"  "FUNCTION"  
follow:  -- empty set --

CharStr
first:   quotedStr  controlChr  
follow:  bracketCls  ")"  ";"  "END"  "EXPORTS"  ","  "name"  "resident"  
         "IN"  "IMPLEMENTATION"  "LABEL"  "CONST"  "RESOURCESTRING"  ":"  
         "TYPE"  "OF"  ".."  "VAR"  "THREADVAR"  "+"  "-"  ">"  "<"  "<="  
         ">="  "<>"  "IS"  "AS"  "OR"  "XOR"  "*"  "/"  "DIV"  "MOD"  "AND"  
         "SHL"  "SHR"  "EXCEPT"  "FINALLY"  "ELSE"  "DO"  "BEGIN"  "THEN"  
         "UNTIL"  "TO"  "DOWNTO"  "PROCEDURE"  "CONSTRUCTOR"  "DESTRUCTOR"  
         "FUNCTION"  "cdecl"  "register"  "pascal"  "safecall"  "stdcall"  
         "virtual"  "dynamic"  "message"  "override"  "overload"  
         "reintroduce"  "near"  "far"  "export"  "external"  "forward"  
         "abstract"  "INITIALIZATION"  "FINALIZATION"  

ControlStr
first:   controlChr  
follow:  bracketCls  quotedStr  ")"  ";"  "END"  "EXPORTS"  ","  "name"  
         "resident"  "IN"  "IMPLEMENTATION"  "LABEL"  "CONST"  
         "RESOURCESTRING"  ":"  "TYPE"  "OF"  ".."  "VAR"  "THREADVAR"  "+"  
         "-"  ">"  "<"  "<="  ">="  "<>"  "IS"  "AS"  "OR"  "XOR"  "*"  "/"  
         "DIV"  "MOD"  "AND"  "SHL"  "SHR"  "EXCEPT"  "FINALLY"  "ELSE"  "DO"  
         "BEGIN"  "THEN"  "UNTIL"  "TO"  "DOWNTO"  "PROCEDURE"  "CONSTRUCTOR"  
         "DESTRUCTOR"  "FUNCTION"  "cdecl"  "register"  "pascal"  "safecall"  
         "stdcall"  "virtual"  "dynamic"  "message"  "override"  "overload"  
         "reintroduce"  "near"  "far"  "export"  "external"  "forward"  
         "abstract"  "INITIALIZATION"  "FINALIZATION"  



List of sets (ANY, SYNC): 
     set[ 0] = EOF  
     set[ 1] = "UNIT"  
     set[ 2] = "MOD"  
     set[ 3] = "widestring"  "STRING"  "PACKED"  "ARRAY"  "RECORD"  "CASE"  
               "SET"  "FILE"  "^"  "OBJECT"  "VAR"  "THREADVAR"  "absolute"  
               "+"  "-"  "@"  "NIL"  "NOT"  ">"  "<"  "<="  ">="  "<>"  "IS"  
               "AS"  "OR"  "SHL"  "SHR"  ":="  "INHERITED"  "GOTO"  "INLINE"  
               "ASM"  "_ASM"  "TRY"  "EXCEPT"  "FINALLY"  "ELSE"  "ON"  "DO"  
               "RAISE"  "AT"  "BEGIN"  "IF"  "THEN"  "REPEAT"  "UNTIL"  
               "WHILE"  "FOR"  "TO"  "DOWNTO"  "WITH"  
     set[ 4] = "widechar"  "ansichar"  "integer"  "cardinal"  "shortint"  
               "smallint"  "longint"  "int64"  "byte"  "word"  
     set[ 5] = "widechar"  "ansichar"  "integer"  "cardinal"  "shortint"  
               "smallint"  "longint"  "int64"  "byte"  "word"  "widestring"  
               "STRING"  "PACKED"  "ARRAY"  "RECORD"  "CASE"  "SHL"  "SHR"  
               ":="  "INHERITED"  "GOTO"  "INLINE"  
     set[ 6] = EOF  bracketOpn  bracketCls  ident  intConst  realConst  
               quotedStr  controlChr  "PROGRAM"  "("  ")"  ";"  "."  "UNIT"  
               "package"  "END"  "requires"  "contains"  "LIBRARY"  "EXPORTS"  
               ","  "index"  "name"  "resident"  "USES"  "IN"  "INTERFACE"  
               "IMPLEMENTATION"  "LABEL"  "CONST"  "RESOURCESTRING"  "="  ":"  
               "TYPE"  "CLASS"  "OF"  "real48"  "real"  "single"  "extended"  
               "currency"  "comp"  "boolean"  "bytebool"  "wordbool"  
               "longbool"  "char"  "widechar"  "ansichar"  "integer"  
               "cardinal"  "shortint"  "smallint"  "longint"  "int64"  "byte"  
               "word"  "longword"  "pchar"  "VARIANT"  "OLEVARIANT"  ".."  
               "shortstring"  "ansistring"  "widestring"  "STRING"  "PACKED"  
               "ARRAY"  "RECORD"  "CASE"  "SET"  "FILE"  "^"  "OBJECT"  "VAR"  
               "THREADVAR"  "absolute"  "+"  "-"  "@"  "NIL"  "NOT"  ">"  "<"  
               "<="  ">="  "<>"  "IS"  "AS"  "OR"  "XOR"  "*"  "/"  "DIV"  
               "MOD"  "AND"  "SHL"  "SHR"  ":="  "INHERITED"  "GOTO"  
               "INLINE"  "ASM"  "_ASM"  "TRY"  "EXCEPT"  "FINALLY"  "ELSE"  
               "ON"  "DO"  "RAISE"  "AT"  "BEGIN"  "IF"  "THEN"  "REPEAT"  
               "UNTIL"  "WHILE"  "FOR"  "TO"  "DOWNTO"  "WITH"  "PROCEDURE"  
               "CONSTRUCTOR"  "DESTRUCTOR"  "FUNCTION"  "OUT"  "cdecl"  
               "register"  "pascal"  "safecall"  "stdcall"  "virtual"  
               "dynamic"  "message"  "override"  "overload"  "reintroduce"  
               "near"  "far"  "export"  "external"  "forward"  "abstract"  
               "INITIALIZATION"  "FINALIZATION"  "PROPERTY"  "public"  
               "protected"  "private"  "published"  "automated"  "stored"  
               "default"  "nodefault"  "read"  "write"  "readonly"  
               "writeonly"  "implements"  "DISPINTERFACE"  "_Tid"  
               "_constExpr"  "_Uid"  "_Lid"  not  
     set[ 7] = "widestring"  "STRING"  "PACKED"  "ARRAY"  "RECORD"  "CASE"  
               "SET"  "FILE"  "^"  "OBJECT"  "VAR"  "THREADVAR"  "absolute"  
               "+"  "-"  "@"  "NIL"  "NOT"  ">"  "<"  "<="  ">="  "<>"  "IS"  
               "AS"  "OR"  "MOD"  "SHL"  "SHR"  ":="  "INHERITED"  "GOTO"  
               "INLINE"  "ASM"  "_ASM"  "TRY"  "EXCEPT"  "FINALLY"  "ELSE"  
               "ON"  "DO"  "RAISE"  "AT"  "BEGIN"  "IF"  "THEN"  "REPEAT"  
               "UNTIL"  "WHILE"  "FOR"  "TO"  "DOWNTO"  "WITH"  
     set[ 8] = "widechar"  "ansichar"  "integer"  "cardinal"  "shortint"  
               "smallint"  "longint"  "int64"  "byte"  "word"  "widestring"  
               "STRING"  "PACKED"  "ARRAY"  "RECORD"  "CASE"  "SET"  "FILE"  
               "^"  "OBJECT"  "VAR"  "THREADVAR"  "absolute"  "+"  "-"  "@"  
               "NIL"  "NOT"  ">"  "<"  "<="  ">="  "<>"  "IS"  "AS"  "OR"  
               "MOD"  "SHL"  "SHR"  ":="  "INHERITED"  "GOTO"  "INLINE"  
               "ASM"  "_ASM"  "TRY"  "EXCEPT"  "FINALLY"  "ELSE"  "ON"  "DO"  
               "RAISE"  "AT"  "BEGIN"  "IF"  "THEN"  "REPEAT"  "UNTIL"  
               "WHILE"  "FOR"  "TO"  "DOWNTO"  "WITH"  
     set[ 9] = "RECORD"  "GOTO"  
     set[10] = "boolean"  "wordbool"  

Undefined nonterminals:   -- none --
Unreachable nonterminals: -- none --
Circular derivations:     -- none --
Underivable nonterminals: -- none --
LL(1) conditions:
  1 LL(1) error in CaseStmt: ";" is the start & successor of a deletable structure
  2 LL(1) error in IfStmt: "ELSE" is the start & successor of a deletable structure
  3 LL(1) error in QualId: "." is the start & successor of a deletable structure
  4 LL(1) error in VariantSection: ";" is the start & successor of a deletable structure
  5 LL(1) error in FieldList: ";" is the start & successor of a deletable structure
  6 LL(1) error in TypedConstant: "(" is the start of several alternatives.
LL(1) errors:     6 !vw


-------- states ---------
       0: #A 5 
          digit 17 
          "[" 2 
          "(" 1 
          "]" 4 
          "." 3 
          "$" 6 
          "'" 12 
          "#" 13 
          ")" 19 
          ";" 20 
          "," 21 
          "=" 22 
          ":" 23 
          "^" 25 
          "+" 26 
          "-" 27 
          "@" 28 
          ">" 29 
          "<" 30 
          "*" 34 
          "/" 35 
E( 9)  1: "." 2 
E( 1)  2:
E(12)  3: ")" 4 
          "." 24 
E( 2)  4:
E( 3)  5: #B 5 
       6: hexDigit 7 
E( 4)  7: hexDigit 7 
E( 5)  8: digit 8 
          #C 9 
       9: digit 11 
          #D 10 
      10: digit 11 
E( 5) 11: digit 11 
      12: noQuote1 12 
          "'" 18 
      13: digit 14 
          "$" 15 
E( 7) 14: digit 14 
      15: hexDigit 16 
E( 7) 16: hexDigit 16 
E( 4) 17: digit 17 
          "." 8 
E( 6) 18: "'" 12 
E(10) 19:
E(11) 20:
E(20) 21:
E(31) 22:
E(32) 23: "=" 36 
E(62) 24:
E(73) 25:
E(78) 26:
E(79) 27:
E(80) 28:
E(83) 29: "=" 32 
E(84) 30: "=" 31 
          ">" 33 
E(85) 31:
E(86) 32:
E(87) 33:
E(92) 34:
E(93) 35:
E(99) 36:

-------- character classes ---------
       eol: { 13,}
underScore: { 95,}
    letter: { 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80,
              81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 97, 98, 99,100,101,102,
             103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,
             119,120,121,122,}
     digit: { 48, 49, 50, 51, 52, 53, 54, 55, 56, 57,}
  hexDigit: { 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 65, 66, 67, 68, 69, 70,
              97, 98, 99,100,101,102,}
  noQuote1: {  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15,
              16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31,
              32, 33, 34, 35, 36, 37, 38, 40, 41, 42, 43, 44, 45, 46, 47, 48,
              49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64,
              65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80,
              81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95, 96,
              97, 98, 99,100,101,102,103,104,105,106,107,108,109,110,111,112,
             113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,
             129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,
             145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,
             161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,
             177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,
             193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,
             209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,
             225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,
             241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,256,
             257,258,259,260,261,262,263,264,265,266,267,268,269,270,271,272,
             273,274,275,276,277,278,279,280,281,282,283,284,285,286,287,288,
             289,290,291,292,293,294,295,296,297,298,299,300,301,302,303,304,
             305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,
             321,322,323,324,325,326,327,328,329,330,331,332,333,334,335,336,
             337,338,339,340,341,342,343,344,345,346,347,348,349,350,351,352,
             353,354,355,356,357,358,359,360,361,362,363,364,365,366,367,368,
             369,370,371,372,373,374,375,376,377,378,379,380,381,382,383,384,
             385,386,387,388,389,390,391,392,393,394,395,396,397,398,399,400,
             401,402,403,404,405,406,407,408,409,410,411,412,413,414,415,416,
             417,418,419,420,421,422,423,424,425,426,427,428,429,430,431,432,
             433,434,435,436,437,438,439,440,441,442,443,444,445,446,447,448,
             449,450,451,452,453,454,455,456,457,458,459,460,461,462,463,464,
             465,466,467,468,469,470,471,472,473,474,475,476,477,478,479,480,
             481,482,483,484,485,486,487,488,489,490,491,492,493,494,495,496,
             497,498,499,500,501,502,503,504,505,506,507,508,509,510,511,512,
             513,514,515,516,517,518,519,520,521,522,523,524,525,526,527,}
        #A: { 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80,
              81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 95, 97, 98, 99,100,101,
             102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,
             118,119,120,121,122,}
        #B: { 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 65, 66, 67, 68, 69, 70,
              71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 81, 82, 83, 84, 85, 86,
              87, 88, 89, 90, 95, 97, 98, 99,100,101,102,103,104,105,106,107,
             108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,}
        #C: { 69,101,}
        #D: { 43, 45,}
Listing:

    1  (*
    2  
    3  
    4    OP4.ATG: Object Pascal 4, ATribbuted Grammar
    5    Version 1999-0121
    6    by   Volker Walter, Metrohm AG, CH9100 Herisau,
    7    Please send errors to "vw@metrohm.ch"
    8  
    9  
   10    This file was produced from Delphi 4 Client Server, Help System,
   11    Index, grammar (Object Pascal). It is the same as in the manual
   12    "Object Pascal Languge Guide" or in the file ".\manuals\OPLG.PDF"
   13    ( 1947793 Bytes from 1998 06 18 04:00).
   14  
   15    It was checked by COCOR until only 6 LL(1) errors came up:
   16      LL(1) conditions:
   17        1 LL(1) error in CaseStmt:
   18                ";" is the start & successor of a deletable structure
   19        2 LL(1) error in IfStmt:
   20                "ELSE" is the start & successor of a deletable structure
   21        3 LL(1) error in QualId:
   22                "." is the start & successor of a deletable structure
   23        4 LL(1) error in VariantSection:
   24                ";" is the start & successor of a deletable structure
   25        5 LL(1) error in FieldList:
   26                ";" is the start & successor of a deletable structure
   27        6 LL(1) error in TypedConstant:
   28                "(" is the start of several alternatives.
   29      LL(1) errors:     6 !vw
   30  
   31    COCOR is a compiler-compiler from " ftp://cs.ru.ac.za/pub/coco ":
   32      Original code in Oberon by Hanspeter Moessenboeck, ETH Zurich
   33      Ported at ETH to Apple Modula, and thence to JPI-2 Modula.
   34      JPI version of 27 January 1991 was then modified to make more
   35      portable by Pat Terry, January - October 1992
   36      This is the IBM-PC MS-DOS Turbo Pascal version for generating Turbo Pascal
   37      based on the port first done by Volker Pohlers, October 1995
   38  
   39    COCOR was modified (see identifiers vw_ ) to handle more
   40      MAXSymbols,MAXNt,MAXLiterals
   41    and to show more information.
   42  
   43  *)
   44  COMPILER Op4;
   45  
   46  CHARACTERS
   47      eol         = CHR(13) .
   48      underScore  = "_" .
   49      letter      = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz" .
   50      digit       = "0123456789" .
   51      hexDigit    = digit + "ABCDEFabcdef" .
   52  
   53      noQuote1    = ANY - "'".
   54  
   55  IGNORE
   56      CHR(9) .. CHR(13)
   57  
   58  COMMENTS      FROM "(*" TO "*)"                                  (*  4- 5 *)
   59  COMMENTS      FROM "{"  TO  "}"
   60  COMMENTS      FROM "//" TO  eol
   61  
   62  TOKENS
   63      bracketOpn =
   64          "[" | "(." .
   65      bracketCls =
   66          "]" | ".)" .
   67      ident =                                                      (*  4- 2 *)
   68          ( letter | underScore )  { letter | underScore | digit } .
   69  
   70      intConst =
   71          digit { digit } | "$" hexDigit { hexDigit } .
   72    (*
   73      problem 111..999 see
   74              number  = digit { digit }
   75                      | digit { digit } CONTEXT ( ".." ) .
   76  
   77    *)
   78      realConst =
   79          digit { digit } "." { digit }
   80          [ ( "E" | "e" ) [ "+" | "-" ] digit { digit } ] .
   81  
   82      quotedStr =                                                  (*  4- 4 *)
   83          "'" { noQuote1 | "''" } "'" .
   84  
   85      controlChr =
   86          "#" ( digit { digit } | '$' hexDigit { hexDigit } ) .
   87  (*  integer is evaluated MOD 256 *)
   88  
   89  
   90  PRODUCTIONS
   91  
   92  (* begin of 'Op4.Ebn' *)
   93  (* vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv *)
   94  (*
   95      not mentioned in grammar from Help system
   96      fixed
   97  
   98      DISPID
   99  
  100      page numbers refer to
  101        Book: Object Pascal Languge Giude
  102        File: .\manulas\OPLG.PDF    1947793 Bytes; 1998061804_0400
  103  *)
  104  
  105      ControlStr =
  106          controlChr { controlChr } .
  107  
  108      CharStr =
  109              ControlStr { quotedStr ControlStr }
  110              | quotedStr { ControlStr quotedStr } .
  111  
  112      Op4=                                                         (*  2- 1 *)
  113          ( Program | Package  | Library  | Unit ) .
  114  
  115      Program =                                                    (*  3- 2 *)
  116          [ "PROGRAM" ident [ "(" IdentList ")" ] ";" ] ProgramBlock "." .
  117  
  118      Unit =                                                       (*  3- 3 *)
  119          "UNIT" ident ";"
  120          InterfaceSection ImplementationSection InitSection "." .
  121  
  122      Package =                                                    (*  9- 7 *)
  123          "package" ident ";"
  124          [ RequiresClause ] [ ContainsClause ] "END" "." .
  125  
  126      RequiresClause =                                             (*  9- 7 *)
  127          "requires" IdentList { IdentList }  ";" .
  128  
  129      ContainsClause =                                             (*  9- 7 *)
  130          "contains" { IdentList }  ";" .
  131  
  132      Library =                                                    (*  9- 3 *)
  133          "LIBRARY" ident ";" [ UsesClause ]
  134          { ExportsClause | DeclSection } CompoundStmt "." .
  135      ExportsClause =
  136         "EXPORTS"  ExpElem { "," ExpElem } ";" .
  137      ExpElem =
  138         ident [ "index" intConst ] [ "name" CharStr ] [ "resident" ] .
  139  
  140  
  141      ProgramBlock =                                               (*  2- 3 *)
  142          [ UsesClause ] Block .
  143  
  144      UsesClause =                                                 (*  3- 6 *)
  145          "USES"
  146          ident [ "IN" CharStr ] { ";" ident [ "IN" CharStr ] } .
  147  
  148      InterfaceSection =                                           (*  3- 3 *)
  149          "INTERFACE" [ UsesClause ] { InterfaceDecl } .
  150  
  151      InterfaceDecl    =                                           (*  3- 3 *)
  152          ConstSection | TypeSection | VarSection | ExportedHeading .
  153  
  154      ExportedHeading =                                            (*  6- 2 *)
  155          ( ProcedureHeading | FunctionHeading ) ";" { Directive ";" } .
  156  
  157      ImplementationSection =                                      (*  3- 4 *)
  158          "IMPLEMENTATION" [ UsesClause ] { DeclSection } .
  159  
  160      Block =                                                      (*  3- 2 *)
  161          { DeclSection } CompoundStmt .
  162  
  163      DeclSection =                                                (*  3- 2 *)
  164          LabelDeclSection | ConstSection | TypeSection | VarSection
  165          | ProcedureDeclSection .
  166  
  167      LabelDeclSection =                                           (*  4- 4 *)
  168          "LABEL"
  169      (* ??orig:
  170          LabelId .
  171      *)
  172          LabelId { "," LabelId } .
  173  
  174      ConstSection =                                               (*  5-38 *)
  175          ( "CONST" ( ConstantDecl ";" ) { ConstantDecl ";" } )
  176          | ResourceDecl .
  177  
  178      ResourceDecl =
  179          "RESOURCESTRING"
  180          ident "=" CharStr { ";" ident "=" CharStr } .
  181  
  182      ConstantDecl =                                               (*  5-38 *)
  183          ident
  184          ( ( "=" ConstExpr ) | ( ":" TypeId "=" TypedConstant ) ) .
  185          (*  true constant       typed constant *)
  186  
  187      TypeSection =                                                (*  5- 1 *)
  188          "TYPE" TypeDecl ";" { TypeDecl ";" } .
  189                    (*  5- 1 ..35 *)
  190      TypeDecl =                                                   (*  5-35 *)
  191          ( ident "=" [ "TYPE" ] ) Type | RestrictedType .
  192      (* !!new:   to define names with different RTTI, and for In and Out *)
  193  
  194      TypedConstant =                                              (*  5-40 *)
  195          ( ConstExpr | ArrayConstant | RecordConstant ) .
  196      (* !! static variable: writable only if $J+ ; $WRITEABLECONST ON *)
  197  
  198      ArrayConstant =                                              (*  5-40 *)
  199          "(" TypedConstant { "," TypedConstant } ")" .
  200  
  201      RecordConstant =                                             (*  5-40 *)
  202          "(" RecordFieldConstant { ";" RecordFieldConstant } ")" .
  203  
  204      RecordFieldConstant =                                        (*  5-41 *)
  205          ident ":" TypedConstant .
  206  
  207      Type =                                                       (*  5- 2 *)
  208          TypeId | SimpleType | StrucType | PointerType | StringType
  209          | ProcedureType | VariantType | ClassRefType.
  210  
  211      RestrictedType =                                             (*  5- 2 *)
  212            ObjectType | ClassType | InterfaceType.
  213  
  214      ClassRefType =                                               (*  7- 3 *)
  215          "CLASS" "OF" TypeId .
  216  
  217      SimpleType =                                                 (*  5- 2 *)
  218          ( OrdinalType | RealType ) .
  219  
  220      RealType =                                                   (*  5- 8 *)
  221          "real48" | "real" | "single" | "double" | "extended"
  222          | "currency" | "comp" .
  223      (* see $REALCOMPATIBILITY, real48 *)
  224  
  225      OrdinalType =                                                (*  5- 2 *)
  226          ( SubrangeType | EnumeratedType | OrdIdent ) .
  227  
  228      OrdIdent =                                                   (*  5- 2 *)
  229          "boolean" | "bytebool" | "wordbool" | "longbool"         (*  5- 5 *)
  230          | "char" | "widechar" | "ansichar"                       (*  5- 4 *)
  231          | "integer" | "cardinal"                                 (*  5- 3 *)
  232          | "shortint" | "smallint" | "longint" | "int64"          (*  5- 4 *)
  233          | "byte" | "word" | "longword"                           (*  5- 4 *)
  234          | "pchar" .
  235  
  236      VariantType =                                                (*  5-29 *)
  237            "VARIANT" | "OLEVARIANT".
  238           (*  5-29 .. 33 *)
  239  
  240      SubrangeType =                                               (*  5- 7 *)
  241          ConstExpr ".." ConstExpr .
  242  
  243      EnumeratedType =                                             (*  5- 6 *)
  244          "(" IdentList ")" .
  245  
  246      StringType =                                                 (*  5- 9 *)
  247          "shortstring" | "ansistring" | "widestring"
  248          | "STRING" bracketOpn ConstExpr bracketCls .
  249  
  250      StrucType =                                                  (*  5-15 *)
  251          [ "PACKED" ] ( ArrayType | SetType | FileType | RecType ) .
  252  
  253      ArrayType =                                                  (*  5-16 *)
  254          "ARRAY"
  255          [ bracketOpn OrdinalType { "," OrdinalType } bracketCls ]
  256          "OF" Type .
  257      (*  !!new:  dynamic array:
  258          BEGIN
  259            SetLength(a,); ... Length(a), High(a); Low(a); ... a:=NIL;
  260          END;
  261          NEVER New(a); Dispose(a);
  262      *)
  263  
  264      RecType =                                                    (*  5-20 *)
  265          "RECORD" [ FieldList ] "END" .
  266  
  267      FieldList =                                                  (*  5-21 *)
  268          FieldDecl { ";" FieldDecl } [ VariantSection ] [ ";" ] .
  269  
  270      FieldDecl =                                                  (*  5-20 *)
  271          IdentList ":" Type .
  272  
  273      VariantSection =                                             (*  5-21 *)
  274          "CASE" [ ident ":"] TypeId "OF" RecVariant { ";" RecVariant } .
  275  
  276      RecVariant =                                                 (*  5-22 *)
  277          ConstExpr { "," ConstExpr } ":" "(" [ FieldList ] ")" .
  278  
  279      SetType =                                                    (*  5-15 *)
  280          "SET" "OF" OrdinalType .
  281  
  282      FileType =                                                   (*  5-23 *)
  283          "FILE" [ "OF" TypeId ] .
  284  
  285      PointerType =                                                (*  5-26 *)
  286          "^" TypeId .
  287  
  288      ProcedureType =                                              (*  5-27 *)
  289          ( ProcedureHeading | FunctionHeading )
  290          [ "OF" "OBJECT" ] [ DirCalling ] .
  291  
  292      VarSection =                                                 (*  5-36 *)
  293          ( "VAR" | "THREADVAR" ) ( VarDecl ";") { VarDecl ";" } .
  294      (* THREADVAR only global *)
  295  
  296      VarDecl =                                                    (*  5-37 *)
  297          IdentList ":" Type
  298          [( "absolute" ( ident | ConstExpr )) | "=" ConstExpr ] .
  299      (*
  300         the first identifier will have specified absolute address
  301         !!new:  = ConstExpr to init global variables
  302         ??difference to  static (C), typed constant (TP)
  303         pages (4- 5, 12 )
  304      *)
  305  
  306      Expression =                                                 (*  4- 5 *)
  307          SimpleExpression { RelOp SimpleExpression } .
  308          (* pages (4- 5, 12 ) *)
  309  
  310      SimpleExpression =                                           (*  4-12 *)
  311          [ "+" | "-" ] Term { AddOp Term } .
  312  
  313      Term =                                                       (*  4-12 *)
  314          Factor { MulOp Factor }.
  315  
  316      Factor =                                                     (*  4-12 *)
  317          Designator [ "(" ExprList ")" ]
  318          | "@" Designator | Number | CharStr
  319          | "NIL" | "(" Expression ")" | "NOT" Factor | SetConstructor
  320          | TypeId "(" Expression ")" .
  321  
  322      RelOp =                                                      (*  4-12 *)
  323          ">" | "<" | "<=" | ">=" | "<>" | "IN" | "IS" | "AS" .
  324  
  325      AddOp =                                                      (*  4-12 *)
  326          "+" | "-" | "OR" | "XOR" .
  327  
  328      MulOp =                                                      (*  4-12 *)
  329          "*" | "/" | "DIV" | "MOD" | "AND" | "SHL" | "SHR" .
  330  
  331      Designator =                                                 (*  4-14 *)
  332          QualId { "." ident | bracketOpn ExprList bracketCls | "^" }.
  333  
  334      SetConstructor =                                             (*  4-13 *)
  335          bracketOpn [ SetElement { "," SetElement } ] bracketCls .
  336  
  337      SetElement =                                                 (*  4-13 *)
  338          Expression [ ".." Expression ] .
  339          (* pages 4-13, 5-15 *)
  340  
  341      ExprList =                                                   (*  4-13 *)
  342          Expression { "," Expression } .
  343  
  344      Statement =                                                  (*  4-17 *)
  345          [ LabelId ":" ] [ SimpleStatement | StructStmt ] .
  346      (*
  347          may be empty
  348          therefore ; may be interpreted as two empty statements
  349      *)
  350      StmtList =                                                   (*  4-20 *)
  351          Statement { ";" Statement } .
  352  
  353      SimpleStatement =                                            (*  4-17 *)
  354          Designator (
  355            [ "(" ExprList ")" ] | ":=" [ "INHERITED" ] Expression
  356          )
  357          | "INHERITED" [ Designator [ "(" ExprList ")" ] ]
  358          | "GOTO" LabelId.
  359  
  360      StructStmt =                                                 (*  4-19 *)
  361          CompoundStmt | ConditionalStmt | LoopStmt | WithStmt
  362          | ExceptStmt | RaiseStmt | AsmStmt | InlineStmt .
  363  
  364      InlineStmt =
  365          "INLINE" "(" intConst { "/" intConst } ")" .
  366      (*
  367          BorlandPascal 7
  368      *)
  369  
  370      AsmStmt =
  371          "ASM" AsmCode { ";" AsmCode } "END" .                    (* 13- 1 *)
  372      (*
  373          eol and comment as statemet separators
  374          assembler !!
  375      *)
  376      AsmCode =
  377          "_ASM" .
  378      ExceptStmt =                                                 (*  7-25 *)
  379          "TRY" StmtList
  380          ( "EXCEPT" ExceptBlock "END" | "FINALLY" StmtList "END" ) .
  381  
  382      ExceptBlock =                                                (*  7-26 *)
  383          ( Statement | ExceptionHandler )
  384          { ";" ( Statement |  ExceptionHandler ) }
  385          [ "ELSE" StmtList ] .
  386  
  387      ExceptionHandler =                                           (*  7-26 *)
  388         "ON" ident "DO" Statement .
  389  
  390      RaiseStmt =                                                  (*  7-25 *)
  391          "RAISE"
  392          [ Designator [ "(" ExprList ")" ]
  393          [ "AT" Expression ] ] .
  394  
  395      CompoundStmt =                                               (*  4-19 *)
  396          "BEGIN" StmtList "END" .
  397      (*
  398             StmtList may be an empty Statement followed by ;
  399      *)
  400  
  401      ConditionalStmt =                                            (*  4-17 *)
  402          IfStmt | CaseStmt .
  403  
  404      IfStmt =                                                     (*  4-22 *)
  405          "IF" Expression "THEN" Statement [ "ELSE" Statement ] .
  406  
  407      CaseStmt =                                                   (*  4-23 *)
  408          "CASE" Expression "OF" CaseSelector { ";" CaseSelector }
  409          [ "ELSE" Statement ] [ ";" ] "END" .
  410  
  411      CaseSelector =                                               (*  4-24 *)
  412          CaseLabel { "," CaseLabel } ":" Statement .
  413  
  414      CaseLabel =                                                  (*  4-24 *)
  415          ConstExpr [ ".." ConstExpr ] .
  416  
  417      LoopStmt =                                                   (*  4-25 *)
  418          RepeatStmt | WhileStmt | ForStmt .
  419  
  420      RepeatStmt =                                                 (*  4-25 *)
  421          "REPEAT" StmtList "UNTIL" Expression .
  422  
  423      WhileStmt =                                                  (*  4-25 *)
  424          "WHILE" Expression "DO" Statement .
  425  
  426      ForStmt =                                                    (*  4-26 *)
  427          "FOR" QualId ":=" Expression
  428          ( "TO" | "DOWNTO" ) Expression "DO" Statement .
  429  
  430      WithStmt =                                                   (*  4-20 *)
  431          "WITH" IdentList "DO" Statement .
  432  
  433      ProcedureDeclSection =                                       (*  6- ? *)
  434          ProcMtDecl | FuncMtDecl .
  435  
  436      ProcMtDecl =
  437          ( "PROCEDURE" | "CONSTRUCTOR" | "DESTRUCTOR" )
  438          QualId  [ FormalParameters ] { Directive }
  439          Block ";" .
  440  
  441      FuncMtDecl =
  442          "FUNCTION"
  443          QualId [ FormalParameters ] { Directive }
  444          ":" ReturnType Block ";" .
  445  
  446  (*
  447  ========================================
  448      TypeQualId =                                                  
  449          TypeId "." ident .
  450  ========================================
  451  *)                                                               (*  7- 8*)
  452  
  453      ReturnType =                                                 (*  7- 8*)
  454          SimpleType | StringType | ClassType .
  455  
  456      FunctionHeading =                                            (*  6- 3 *)
  457          "FUNCTION" ident [ FormalParameters ] ":" ReturnType .
  458  
  459      ProcedureHeading =                                           (*  6- 2 *)
  460          "PROCEDURE" ident [ FormalParameters ] .
  461  
  462      FormalParameters =                                           (*  6- 9 *)
  463          "("  FormalParm { ";" FormalParm } ")" .
  464  
  465      FormalParm =                                                 (*  6- 9 *)
  466          [ "VAR" | "CONST" | "OUT" ] Parameter .
  467  
  468      Parameter =                                                  (*  6- 9 *)
  469  (*
  470  ========================================  not LL(1)
  471      identlist starts with ident, default param starts with ident
  472  
  473        IdentList [ ":" ( ["ARRAY" "OF"] SimpleType | "STRING" | "FILE" ) ]
  474        | ident ":" SimpleType "=" ConstExpr .
  475  
  476        default param
  477          [ "CONST" ] ident ":" SimpleType "=" ConstExpr .
  478        only at the end of the 'FormalParameters'
  479  
  480        normal param
  481          IdentList [ ":" ( ["ARRAY" "OF"] SimpleType | "STRING" | "FILE" ) ]
  482      files only in VAR
  483  
  484      ident  ( ":" (
  485        SimpleType [ "=" ConstExpr ]) |
  486        ( "ARRAY" "OF" SimpleType | "STRING" | "FILE" )
  487      ) .
  488  
  489  
  490      this definition should parse ALL Parameter 'FormalParameters'
  491      !! but parses too much
  492  ========================================
  493  *)
  494         ident
  495         ( "," ident { ","  ident } ":"
  496           ( [ "ARRAY" "OF"] SimpleType | "STRING" | "FILE" )
  497         ) |
  498         ":" Type [ "=" ConstExpr ] .
  499  
  500      (* !!new
  501            default parameters 6-16: ident ":" SimpleType "=" ConstExpr
  502            distinguish:             open arrays (ARRAY OF), dynamic arrays
  503             pages : 6- 9,12,16
  504      *)
  505  
  506      DirCalling =
  507         "cdecl" | "register"  | "pascal" | "safecall" | "stdcall" .
  508      DirBinding =
  509         "virtual" [ ConstExpr ] | "dynamic"
  510         | "message" ConstExpr                                     (*  7-15 *)
  511         | "override" | "overload"
  512         | "reintroduce" .                                         (*  7-11 *)
  513      Dir16Bit =
  514        "near" | "far" | "export" .
  515      Directive =                                                  (*  6- 4 *)
  516      (*  !!orig:
  517          !!new
  518            overload    like C++
  519            reintroduce
  520  
  521            procedure and function (6- 6, 6- 7)
  522                forward, overload
  523            Method binding
  524                dynamic, virtual, override, overload
  525      *)
  526          DirCalling
  527          | Dir16Bit
  528          | "external" CharStr [ "name" CharStr ]                  (*  6- 7 *)
  529          | "forward"                                              (*  6- 6 *)
  530          | "abstract"                                             (*  7-12 *)
  531          | DirBinding .
  532  
  533      ObjectType =                                                 (*  7- 4 *)
  534          "OBJECT" [ ObjHeritage ]
  535              ClassVisibility
  536              { ObjFld ClassVisibility }
  537              { ObjMth ClassVisibility }
  538          "END" .
  539  
  540      ObjFld =
  541          IdentList ":" Type ";" .
  542  
  543      ObjMth =
  544          MethodHeading ";" { Directive ";" } .
  545  
  546      ObjHeritage =                                                (*  7- 4 *)
  547          "(" QualId ")" .
  548      
  549      MethodHeading =                                              (*  7- 4 *)
  550          ProcedureHeading | FunctionHeading
  551          | ConstructorHeading | DestructorHeading .
  552  
  553      ConstructorHeading =                                         (*  7- 4 *)
  554          "CONSTRUCTOR" ident [ FormalParameters ] .
  555  
  556      DestructorHeading =                                          (*  7- 4 *)
  557          "DESTRUCTOR" ident [ FormalParameters ] .
  558  
  559      InitSection =                                                (*  3- 4 *)
  560          "INITIALIZATION" StmtList [ "FINALIZATION" StmtList ] "END"
  561          | "BEGIN" StmtList "END"
  562          | "END" .
  563  
  564      ClassType =                                                  (*  7- 2 *)
  565      (* ??orig:
  566          "CLASS" [ClassHeritage]
  567          [ClassFieldList] [ClassMethodList] [ClassPropertyList] "END" .
  568  
  569          compiler accepts examples
  570              x1=CLASS END;        if no heritage  declaration with END;
  571            XOR
  572              x0=CLASS (tObject);  if only heritage ; FORWARD (7 -6)
  573          ";" does not belong to ClassType but it is end of TypeDecl
  574  
  575          fields, methods, properties may be mixed
  576          see                     InterfaceSection =   ..... {InterfaceDecl} .
  577          'MemberList'            as a new syntactiacl element
  578          MemberList              may be empty
  579          ClassVisibility         may be repeated
  580      *)
  581  (*
  582  ======================================== was wrong
  583          "CLASS" MemberList "END" | ClassHeritage [ MemberList "END" ] .
  584  ======================================== not LL(1) , see DeclSection
  585          "CLASS" [ClassHeritage] [ MemberList "END" ] .
  586          Memberlist= {  .... }
  587  
  588          MemberList =
  589          ClassVisibility ";" | ClassFieldList |
  590          ClassMethodList | ClassPropertyList .
  591  
  592  
  593      next
  594          "CLASS" [ClassHeritage] [ { MemberList } "END" ] .
  595          changed like
  596          'ObjectType'
  597  
  598  *)
  599          "CLASS" [ ClassHeritage ]
  600              ClassVisibility
  601              { ObjFld ClassVisibility }
  602              { ClsMthProp ClassVisibility }
  603          "END" .
  604  
  605      MethodResolution =                                            (* 10-5 *)
  606           "." ident "=" ident .
  607  
  608      ClsProcHeading =                                       (*  6- 2, 10-5 *)
  609          "PROCEDURE" ident
  610          ( [ FormalParameters ] | MethodResolution ) .
  611  
  612      ClsFuncHeading =                                            (*  6- 3 *)
  613          "FUNCTION" ident
  614          ( ( [ FormalParameters ] ":" ReturnType ) | MethodResolution ) .
  615  
  616      ClsMethodHeading =
  617          ClsProcHeading | ClsFuncHeading
  618          | ConstructorHeading | DestructorHeading .
  619  
  620      ClsMthProp =
  621          ( ClsMethodHeading ";" { Directive ";" } )
  622          |
  623          ( "PROPERTY" ident [ PropertyInterface ]  PropertySpecifiers ) .
  624  
  625      ClassHeritage =                                              (*  7- 2 *)
  626          "(" IdentList ")" .
  627      (* !!new: list of identifiers, multiple inheritance only in INTERFACE *)
  628  
  629      ClassVisibility =                                            (*  7- 4 *)
  630          { "public" | "protected" | "private" | "published" | "automated" } .
  631  
  632      PropertyInterface =                                          (*  7-16 *)
  633          [ PropertyParameterList ] ":" ident .
  634  
  635      PropertyParameterList =                                      (*  7-19 *)
  636          bracketOpn
  637            ( IdentList ":" TypeId ) { ";" ( IdentList ":" TypeId ) }
  638          bracketCls .
  639  
  640      StorageSpecifier =
  641          ( "stored" ( ident | ConstExpr ) )
  642          | ( "default" ConstExpr ) | "nodefault" .
  643  
  644      AccessSpecifier =
  645          ( "read"  ident ) | ( "write" ident )
  646          | "readonly" | "writeonly" .
  647  
  648      PropertySpecifiers =                                         (*  7-20 *)
  649          [ "index" ConstExpr]
  650          AccessSpecifier { AccessSpecifier }
  651          [ StorageSpecifier ]
  652          [ "implements" TypeId] .
  653  
  654      InterfaceType =                                               (*10- 1*)
  655          ( "INTERFACE" | "DISPINTERFACE"  )
  656          [ [ InterfaceHeritage ]
  657            { ClsMthProp ClassVisibility }
  658          "END" ] .
  659  
  660      InterfaceHeritage =                                           (*10- 1 *)
  661         "(" IdentList ")" bracketOpn CharStr bracketCls .
  662  
  663      
  664      IdentList =                                                  (*  5- 6 *)
  665          ident { ","  ident } .
  666  
  667      QualId =                                                     (*  4- 2 *)
  668      (* ??orig:
  669          [UnitId "."] ident .
  670          may be           TypeId.MethodId   ??
  671      *)
  672         ident [ "." ident] .
  673  
  674      TypeId =                                                     (*  5-35 *)
  675          [ UnitId "." ] "_Tid" .
  676  
  677      ConstExpr =                                                  (*  5-39 *)
  678          "_constExpr" .
  679  
  680                                                              (* ? typecast *)
  681      UnitId =                                                     (*  3- 3 *)
  682          "_Uid" .                                            (* identifier *)
  683  (*
  684          ident
  685  LL(1) error in VariantSection:
  686  ident is the start & successor of a deletable structure
  687  *)
  688      LabelId =                                                    (*  4- 4 *)
  689          intConst | "_Lid".             (* integer 0 .. 9999 | identifier  *)
  690  (*
  691          ident
  692  LL(1) error in Statement:
  693  ident is the start & successor of a deletable structure
  694  *)
  695      Number =                                                     (*  4- 4 *)
  696          realConst | intConst .
  697  
  698      (* $ Op4 *)
  699      (* vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv *